diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java
new file mode 100644
index 000000000..1ff820244
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java
@@ -0,0 +1,45 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Rotate3D<T extends Noise3D>
+    extends Rotate2D<T>
+    implements Noise3D {
+    private final double @NotNull [] @NotNull [] rot;
+
+    public Rotate3D(@NotNull final T noise, final double xRot, final double yRot, final double zRot) {
+        super(noise, yRot);
+
+        final double cx = Math.cos(xRot), sx = Math.sin(xRot);
+        final double cy = Math.cos(yRot), sy = Math.sin(yRot);
+        final double cz = Math.cos(zRot), sz = Math.sin(zRot);
+
+        this.rot = new double[][] {
+            {  cy*cz,            -cy*sz,             sy    },
+            {  sx*sy*cz + cx*sz, -sx*sy*sz + cx*cz, -sx*cy },
+            { -cx*sy*cz + sx*sz,  cx*sy*sz + sx*cz,  cx*cy }
+        };
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        final double nx = this.rot[0][0] * x + this.rot[0][1] * y + this.rot[0][2] * z;
+        final double ny = this.rot[1][0] * x + this.rot[1][1] * y + this.rot[1][2] * z;
+        final double nz = this.rot[2][0] * x + this.rot[2][1] * y + this.rot[2][2] * z;
+
+        return this.noise.getValue(nx, ny, nz);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        throw new UnsupportedOperationException("Not implemented!");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java
new file mode 100644
index 000000000..2e504f3a4
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Scale2D<T extends Noise2D>
+    implements Noise2D {
+    protected final @NotNull T noise;
+    protected final double xScale;
+    protected final double zScale;
+
+    public Scale2D(final @NotNull T noise, final double xScale, final double zScale) {
+        this.noise = noise;
+        this.xScale = 1.0 / xScale;
+        this.zScale = 1.0 / zScale;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        return this.noise.getValue(x * this.xScale, z * this.zScale);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        return this.noise.addRegion(out, x, z, xSize, zSize, xScale * this.xScale, zScale * this.zScale, amplitude);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java
new file mode 100644
index 000000000..f578c5301
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Scale3D<T extends Noise3D>
+    extends Scale2D<T>
+    implements Noise3D {
+    protected final double yScale;
+
+    public Scale3D(@NotNull final T noise, final double xScale, final double yScale, final double zScale) {
+        super(noise, xScale, zScale);
+
+        this.yScale = yScale;
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        return this.noise.getValue(x * this.xScale, y * this.yScale, z * this.zScale);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        return this.noise.addRegion(out, x, y, z, xSize, ySize, zSize, xScale * this.xScale, yScale * this.yScale, zScale * this.zScale, amplitude);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java
new file mode 100644
index 000000000..46e1b9380
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Warp2D<A extends Noise2D, B extends Noise2D, C extends Noise2D>
+    implements Noise2D {
+    protected final @NotNull A base;
+    protected final @NotNull B warpX;
+    protected final @NotNull C warpZ;
+
+    public Warp2D(final @NotNull A base, final @NotNull B warpX, final @NotNull C warpZ) {
+        this.base = base;
+        this.warpX = warpX;
+        this.warpZ = warpZ;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        return this.base.getValue(
+            x + this.warpX.getValue(x, z),
+            z + this.warpZ.getValue(x, z)
+        );
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        throw new UnsupportedOperationException("Not implemented!");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java
new file mode 100644
index 000000000..f2c8dc289
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Warp3D<A extends Noise3D, B extends Noise3D, C extends Noise3D, D extends Noise3D>
+    extends Warp2D<A, B, D>
+    implements Noise3D {
+    protected final @NotNull C warpY;
+
+    public Warp3D(final @NotNull A base, final @NotNull B warpX, final @NotNull C warpY, final @NotNull D warpZ) {
+        super(base, warpX, warpZ);
+
+        this.warpY = warpY;
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        return this.base.getValue(
+            x + this.warpX.getValue(x, y, z),
+            y + this.warpY.getValue(x, y, z),
+            z + this.warpZ.getValue(x, y, z)
+        );
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        throw new UnsupportedOperationException("Not implemented!");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
index 5eb54d04f..b3b168cae 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
@@ -19,7 +19,7 @@ public class WorldTypeOverworldFloating
         return new BiomeProviderOverworld(world.getRandomSeed(), this)
                 .withTemperatureScales(0.00625, 0.00625, 0.25, 0.01)
                 .withHumidityScales(0.0125, 0.0125, 0.3, 0.01)
-                .withFuzzinessScales(8, 8, 0.025);
+                .withNoiseScales(8, 8, 0.025);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java b/game/core/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
index d92ba3b2a..a4b99fffa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
+++ b/game/core/src/main/java/net/minecraft/core/world/wind/WindProviderGeneric.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.wind;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 
 import java.util.Random;
 
@@ -11,8 +11,8 @@ public class WindProviderGeneric extends WindProvider {
     private long randomSeed = -1;
     private Random directionRandom = null;
     private Random intensityRandom = null;
-    private ImprovedNoise directionNoise = null;
-    private ImprovedNoise intensityNoise = null;
+    private ImprovedPerlinNoise directionNoise = null;
+    private ImprovedPerlinNoise intensityNoise = null;
     
     private long lastSampleTime = -1;
     private double lastDirectionSample = 0F;
@@ -22,9 +22,9 @@ public class WindProviderGeneric extends WindProvider {
         if (randomSeed != world.getRandomSeed() || directionRandom == null || intensityRandom == null || directionNoise == null || intensityNoise == null) {
             randomSeed = world.getRandomSeed();
             directionRandom = new Random(randomSeed * 0x3F6D);
-            directionNoise = new ImprovedNoise(directionRandom);
+            directionNoise = new ImprovedPerlinNoise(directionRandom);
             intensityRandom = new Random(randomSeed * 0x0C6F);
-            intensityNoise = new ImprovedNoise(intensityRandom);
+            intensityNoise = new ImprovedPerlinNoise(intensityRandom);
         }
     }
     
